<template>
  <div>
    <slot></slot>
  </div>
</template>

<script>
import {provideDatas, provideMethods} from "@/libs/genProvider";
import {
  getMineRoadTrips as getMineRoadTripsAction,
  getAllRoadTrips as getAllRoadTripsAction,
  getRoadTripOfAnotherUser as getRoadTripOfAnotherUserAction,
  deleteRoadTrip as deleteRoadTripAction,
  getOneRoadTrip as getOneRoadTripAction,
  updateRoadTripName as updateRoadTripNameAction
} from "@/actions/RoadTripsGestionAction";
import {reactFromAPI, reactFromAPIDelete} from "../libs/reactFromAPI";
import {
  findUsers as findUsersAction,
  getUserById as getUserByIdAction
} from "@/actions/UsersAction";

export default {
  name: "RoadTripsGestionProvider",
  inject: ["createAlert"],
  provide() {
    const provider = {};

    provideDatas(provider, "roadtripsGestion", this, true);
    provideMethods(provider, "roadtripsGestion", this);

    return provider;
  },
  data: () => ({
    mineRoadtrips: null,
    allRoadTrips: null,
    roadtripsByUserId: {},
    roadTripsById: {},
    currentRoadTrip: null,
    usersById: {},
    foundUsers: null,
    userSearch: '',
    roadtripsForUserLoaded: false,
    comeFrom: null,
  }),
  beforeMount() {
    this.getVariablesByMode();
  },
  methods: {
    getVariablesByMode() {
      this.foundUsers = null;
      this.userSearch = '';
      this.roadtripsForUserLoaded = false;
      if (this.$route.name === "roadtrips-admin") {
        if (this.allRoadTrips === null) {
          getAllRoadTripsAction()
              .then(res => res.json())
              .then(roadtrips => {
                this.allRoadTrips = roadtrips.map(roadtrip =>
                    this.roadTripsById[roadtrip._id]??roadtrip
                );
                this.setRoadTripsById(roadtrips);
                this.getRoadTripsUsers(roadtrips);
              })
        }
        return;
      }
      if (this.$route.name === "roadtrips-other-user") {
        if (this.roadtripsByUserId[this.$route.params.id] === undefined) {
          getRoadTripOfAnotherUserAction(this.$route.params.id)
              .then(res => res.json())
              .then(roadtrips => {
                this.roadtripsByUserId[this.$route.params.id] = roadtrips.map(roadtrip =>
                    this.roadTripsById[roadtrip._id]??roadtrip
                );
                this.setRoadTripsById(roadtrips);
                this.getRoadTripsUsers(roadtrips);
                this.roadtripsForUserLoaded = true;
              })
        } else
          this.roadtripsForUserLoaded = true;
        return;
      }
      if (this.$route.name === "roadtrips" && this.mineRoadtrips === null) {
        getMineRoadTripsAction()
            .then(res => res.json())
            .then(roadtrips => {
              this.mineRoadtrips = roadtrips.map(roadtrip =>
                  this.roadTripsById[roadtrip._id]??roadtrip
              );
              this.setRoadTripsById(roadtrips);
            })
        return;
      }
      if (this.$route.name === "show-roadtrip") {
        this.findRoadTripToShow(this.$route.params.id);
      }
    },
    setRoadTripsById(roadTrips) {
      this.roadTripsById = {
        ...roadTrips.reduce((acc,roadTrip) => ({
          ...acc,
          [roadTrip._id]: acc[roadTrip._id]??roadTrip
        }), this.roadTripsById)
      }
    },
    async getRoadTripsUsers(roadtrips) {
      this.usersById = {
        ...this.usersById,
        ...(
            await Promise.all(
                roadtrips
                  .filter(({userId}) => this.usersById[userId] === undefined)
                  .map(({userId}) =>
                      getUserByIdAction(userId)
                        .then(async res =>
                            [userId,res.status === 200 ? await res.json() : null]
                        )
                  )
            ).then(users =>
              users.reduce((acc,[userId,user]) => ({
                ...acc,
                [userId]: user
              }), {})
            )

        )
      }
    },
    goBack() {
      this.$router.push(this.comeFrom ?? {name: "roadtrips"});
      this.comeFrom = null;
    },
    showRoadTrip(id) {
      this.comeFrom = {name: this.$route.name, params: this.$route.params};
      this.$router.push({name: "show-roadtrip", params: {id}})
    },
    findRoadTripToShow(id) {
      if (this.currentRoadTrip === null || this.currentRoadTrip._id !== id) {
        this.currentRoadTrip = null;
        if (this.roadTripsById[id]) {
          this.currentRoadTrip = this.roadTripsById[id];
          return;
        }
        getOneRoadTripAction(id).then(res =>
          reactFromAPI(
              res,
              {},
              this.createAlert,
              null,
              200
          ).then(async success => {
            if (!success)
              return;
            const roadTrip = await res.json();
            if (!this.usersById[roadTrip.userId])
              getUserByIdAction(roadTrip.userId)
                .then(res => res.status === 200 ? res.json() : null)
                .then(user => {
                  this.usersById = {
                    ...this.usersById,
                    ...(user ? {[user.id]: user} : {})
                  }
                })
            this.roadTripsById[id] = roadTrip;
            this.currentRoadTrip = roadTrip
          })
        )
      }
    },
    deleteRoadTrip(id) {
      if (!confirm("Voulez-vous vraiment supprimer ce road trip ?"))
        return;
      deleteRoadTripAction(id).then(res =>
        reactFromAPIDelete(
            res,
            {},
            this.createAlert,
            "Road trip supprimé avec succès!"
        ).then(success => {
          if (!success)
            return;
          if (this.mineRoadtrips)
            for (let i=0;i<this.mineRoadtrips.length;i++) {
              if (this.mineRoadtrips[i]._id === id) {
                this.mineRoadtrips.splice(i,1);
                break;
              }
            }
          if (this.allRoadTrips)
            for (let i=0;i<this.allRoadTrips.length;i++) {
              if (this.allRoadTrips[i]._id === id) {
                this.allRoadTrips.splice(i,1);
                break;
              }
            }
          this.roadtripsForUserLoaded = false;
          for (const roadTrips of Object.values(this.roadtripsByUserId)) {
            let found = false;
            for (let i=0;i<roadTrips.length;i++) {
              if (roadTrips[i]._id === id) {
                roadTrips.splice(i,1);
                found = true;
                break;
              }
            }
            if (found)
              break;
          }
          this.roadtripsForUserLoaded = true;
        })
      )
    },
    saveRoadTrip() {
      if (this.currentRoadTrip === null)
        return;
      updateRoadTripNameAction(this.currentRoadTrip._id,this.currentRoadTrip.roadtrip.name)
          .then(res =>
            reactFromAPI(
                res,
                {},
                this.createAlert,
                "Sauvegarde réussie !",
                200
            ).then(async success => {
              if (!success)
                return;

              const {roadtrip: {name}} = await res.json();
              this.currentRoadTrip.roadtrip.name = name;
            })
          )
    },
    selectUser(id) {
      this.foundUsers = null;
      this.userSearch = '';
      if (id === null) {
        this.$router.push({name: "roadtrips-admin"});
        return;
      }
      this.$router.push({name: "roadtrips-other-user", params: {id}})
    },
    findUsers() {
      findUsersAction(1, this.userSearch)
        .then(res => res.json())
        .then(({users}) => {
          this.foundUsers = users;
          this.usersById = {
            ...this.usersById,
            ...users.reduce((acc,user) => ({
              ...acc,
              [user.id]: user
            }), {})
          }
        })
    }
  },
  computed: {
    roadTrips() {
      if (this.$route.name === "roadtrips-admin")
        return this.allRoadTrips;
      if (this.$route.name === "roadtrips-other-user")
        return this.roadtripsForUserLoaded ? this.roadtripsByUserId[this.$route.params.id]??null : null
      return this.mineRoadtrips;
    },
    selectedUser() {
      return (this.$route.name === "roadtrips-other-user" && this.usersById) ? this.usersById[this.$route.params.id]??null : null
    },
    isAdminMode() {
      return ['roadtrips-admin','roadtrips-other-user'].includes(this.$route.name);
    },
    isOtherUser() {
      return this.$route.name === "roadtrips-other-user"
    }
  },
  watch: {
    $route() {
      this.getVariablesByMode()
    },
    userSearch(search) {
      this.foundUsers = null;
      if (search.length <= 1)
        return;
      this.findUsers();
    }
  }
}
</script>

<style scoped>

</style>
